function annozillaOnLocationChange(aWebProgress, aRequest, aLocation) {
	this.__annozillasupport__onLocationChange(aWebProgress, aRequest, aLocation);

    try {
        var oObserverService = Components.classes["@mozilla.org/observer-service;1"].getService();
        oObserverService = oObserverService.QueryInterface(Components.interfaces.nsIObserverService);
        oObserverService.notifyObservers (undefined, "AnnozillaLocationChange", aLocation.spec);
    } catch (e) {
        var csClass = Components.classes['@mozilla.org/consoleservice;1'];
        var cs = csClass.getService(Components.interfaces.nsIConsoleService);
        cs.logStringMessage ("onLocationChange, failed to notify observers: " + e);
    }

}

function AnnozillaServiceStartup()
{
	if (window.nsBrowserStatusHandler)
	{
		nsBrowserStatusHandler.prototype.__annozillasupport__onLocationChange = nsBrowserStatusHandler.prototype.onLocationChange;
		nsBrowserStatusHandler.prototype.onLocationChange = annozillaOnLocationChange;

		var b = getBrowser();
		if (b && b.mTabProgressListener)
		{
			b.__annozillasupport__mTabProgressListener = b.mTabProgressListener;
			b.mTabProgressListener = function(aTabBrowser, aTab, aStartsBlank)
			{
				var ret = aTabBrowser.__annozillasupport__mTabProgressListener(aTabBrowser, aTab, aStartsBlank);
				ret.__annozillasupport__onLocationChange = ret.onLocationChange;
				ret.onLocationChange = annozillaOnLocationChange;
				return ret;
			}
		}

	}

	window.removeEventListener('load', AnnozillaServiceStartup, false);
}

window.addEventListener('load', AnnozillaServiceStartup, false);
